package FJsc;

import java.util.*;
import FJsc.typechecker.*;
import FJsc.typechecker.typeassum.ClassType;
import FJsc.typechecker.typeassum.MethHeaders;

public class Context{

    private HashMap sources=new HashMap(),binaries=new HashMap();

    public Context(){}

    public Context(HashMap sources,HashMap binaries){
	this.sources=sources;
	this.binaries=binaries;
    }

    public HashMap getSources(){
	return sources;
    }

    public HashMap getBinaries(){
	return binaries;
    }

    public Env getEnv()throws TypecheckerException{
	Env e=new Env();
	ConsSigs css=new ConsSigs();
	css.add(new Types());
	e.put("java.lang.Object",new ClassType(null,new FieldDecs(),css, new MethHeaders()));
	Iterator it=binaries.keySet().iterator();
	Object key; // should be a class name
	while(it.hasNext()){
	    key=it.next();
	    e.update((String)key,((ClassDec) binaries.get(key)).getClassType());
	}
	it=sources.keySet().iterator();
	while(it.hasNext()){
	    key=it.next();
	    if(!binaries.containsKey(key))
		e.update((String)key,((ClassDec) sources.get(key)).getClassType());
	}
	e.wellFormed();
	return e;
    }

    public String toString(){
	return "sources= "+sources+"\nbinaries= "+binaries;
    }

}
