package FJsc;

import java.io.*;
import java.util.*;
import FJsc.typechecker.*;

class FilterSources implements FilenameFilter{
    public boolean accept(File dir,String name){
	return name.endsWith(".java");
    }
}

class FilterBinaries implements FilenameFilter{
    public boolean accept(File dir,String name){
	return name.endsWith(".class");
    }
}

public class Extractor{

    private File dir=new File(".");

    public Extractor(){}

    public Extractor(File dir){
	this.dir=dir;
    }

    public Context getContext()throws IOException,ParserException,ClassNotFoundException{
	// extracts all source class decs in current dir
	HashMap sources=new HashMap(); 
	String fileName,className;
	File[] files=dir.listFiles(new FilterSources());
	for(int i=0;i<files.length;i++){
	    fileName=files[i].getName();
	    className=fileName.substring(0,fileName.length()-5);
	    System.out.println("Extracting class "+className);
	    sources.put(className,new Parser(className).parseClassDec());
	}
	// extracts all bin class decs in current dir s.t.
        // either they do not have corresponding source, or they have a less recent source
	HashMap binaries=new HashMap();
	files=dir.listFiles(new FilterBinaries());
	for(int i=0;i<files.length;i++){
	    fileName=files[i].getName();
	    className=fileName.substring(0,fileName.length()-6);
	    File classFile=new File(fileName);
	    if(classFile.exists()){
	    File sourceFile=new File(className+".java");
	    File tcFile=new File(className+".tc");
		if(!sourceFile.exists() || 
		   tcFile.exists() && Math.min(classFile.lastModified(),tcFile.lastModified())>sourceFile.lastModified())
		    binaries.put(className,new BinaryParser(className).parseBinaryClassDec());
	    }
	}
	return new Context(sources,binaries);
    }

    public static void main(String[] args)throws IOException,ParserException,ClassNotFoundException,TypecheckerException{
	Extractor e=new Extractor();
	System.out.println(e.getContext());
	System.out.println(e.getContext().getEnv());
    }
}
