package FJsc;

import java.util.*;
import java.io.*;
import FJsc.typechecker.*;
import FJsc.typechecker.typeassum.*;

public class FJsc{

    public static boolean verbose;

    public static void main(String[] args){
	verbose=args.length>0 && args[0].equals("-v");
	try{
	    Context ctx=new Extractor().getContext();
	    Env ce=ctx.getEnv();
	    HashMap sources=ctx.getSources();
	    HashMap binaries=ctx.getBinaries();
	    LocEnv le;
	    Set s=Selector.select(ctx,ce,verbose);
	    if(s.isEmpty())
		return;
	    Iterator it=s.iterator();
	    TypeAssumOutputStream oos;
	    String className;
	    String fname;
	    PrintStream ps;
	    while(it.hasNext()){
		className=(String)it.next();
		le=new LocEnv();
		System.out.println("Compiling class "+className);
		if(sources.containsKey(className))
		    ((ClassDec)sources.get(className)).typecheck(ce,le);
		else
		    ((ClassDec)binaries.get(className)).typecheck(ce,le);
		oos=new TypeAssumOutputStream(new FileOutputStream(className+".tc")); 
		oos.writeTypeAssum(le);
		oos.close();
	    }
	    try{
		fname=verbose?args[1]:args[0];
		ps=new PrintStream(new FileOutputStream(fname));
	    }
	    catch(ArrayIndexOutOfBoundsException e){
		ps=System.out;
	    }
	    it=s.iterator();
	    while(it.hasNext())
		ps.println((String)it.next()+".java");
	    ps.close();
	}
	catch(IOException e){
	    System.out.println("I/O error: "+e.getMessage());
	}
	catch(ClassNotFoundException e){
	    System.out.println("Cannot find class "+e.getMessage());
	}
	catch(ParserException e){
	    System.out.println("Parse error: "+e.getMessage());
	} 
	catch(TypecheckerException e){
	    System.out.println("Typecheck error: "+e.getMessage());
	}
     }
}
