package FJsc.typechecker;

import java.io.IOException;
import java.util.Collection;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.Field;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.generic.Type;
import FJsc.typechecker.typeassum.*;

public class BinaryClassDec implements ClassDec{

    private JavaClass jc;
    private LocEnv le;

    public BinaryClassDec(JavaClass jc,LocEnv le){
	this.jc=jc;
	this.le=le;
    }

    public JavaClass getJavaClass(){
	return jc;
    }

    public LocEnv getLocEnv(){
	return le;
    }

    public ClassType getClassType(){
	Field[] af=jc.getFields();
	Method[] am=jc.getMethods();
	FieldDecs fds=new FieldDecs();
	ConsSigs css=new ConsSigs();
	MethHeaders mhs=new MethHeaders();
	MethSig ms;
	Types ts;
        Type[] at;
	String name;
	for(int i=0;i<af.length;i++) // fields
	    fds.put(af[i].getName(),af[i].getType());
	for(int i=0;i<am.length;i++){ // constructors and methods
	    name=am[i].getName();
	    at=am[i].getArgumentTypes();
	    if(name.charAt(0)=='<'){// constructor
		ts=new Types();
		for(int j=0;j<at.length;j++)
		    ts.addLast(at[j]);
		css.add(ts);
	    }
	    else{ // method
		ms=new MethSig(name);
		for(int j=0;j<at.length;j++)
		    ms.addLast(at[j]);
		mhs.put(ms,am[i].getReturnType());
	    }

	}
	return new ClassType(jc.getSuperclassName(),fds,css,mhs);
    }

    public void typecheck(Env ce,LocEnv le)throws TypecheckerException,IOException{}

}
