package FJsc.typechecker;

import java.io.*;
import org.apache.bcel.classfile.*;
import FJsc.typechecker.typeassum.*;

public class BinaryParser{

    private ClassParser cp;
    private TypeAssumInputStream ois;
    private String className;

    public BinaryParser(String className)throws IOException{
	this.className=className;
	cp=new ClassParser(className+".class");
	try{
	ois=new TypeAssumInputStream(new FileInputStream(className+".tc"));
	}
	catch(FileNotFoundException e){ois=null;}
    }

    public BinaryClassDec parseBinaryClassDec()throws IOException,ClassNotFoundException,ParserException{
	JavaClass jc;
	try{
	    jc=cp.parse();
	}
	catch(IOException e){throw new ParserException("Bad class file format");}
	String className=jc.getClassName();
	//	if("Object".equals(className)||"java.lang.Object".equals(className))
	//  throw new ParserException("Class Object cannot be redefined");
	if(!className.equals(this.className))
	    throw new ParserException("Class "+className+" must be defined in file "+className+".java");
	LocEnv le;
	if(ois==null)
	    le=new LocEnv();
	else
	    le=(LocEnv) ois.readTypeAssum();
	return new BinaryClassDec(jc,le);
    }

}
