package FJsc.typechecker;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;
import java.util.NoSuchElementException;
import FJsc.typechecker.typeassum.*;
import org.apache.bcel.generic.Type;

public class Env extends HashMap{

    public Object put(String className,ClassType ct){
	if("Object".equals(className))
	    className="java.lang.Object";
	return super.put(className,ct);
    }

    public Object update(String className,ClassType ct)throws TypecheckerException{
	Object o=put(className,ct);
	if(o!=null)
	    throw new TypecheckerException("Class "+className+" is already defined");
	return o;
    }

    private ClassType checkedGet(String className)throws TypecheckerException{
	ClassType ct=((ClassType) get(className));
	if(ct==null)
	    throw new UndefClassException(className);
	return ct;
    }

    public String getSuperclass(String className)throws TypecheckerException{
	return checkedGet(className).getSuperclass();
    }

    public FieldDecs getFields(String className)throws TypecheckerException{
	return checkedGet(className).getFields();
    }

    public ConsSigs getCons(String className)throws TypecheckerException{
	return checkedGet(className).getCons();
    }

    public MethHeaders getMeths(String className)throws TypecheckerException{
	return checkedGet(className).getMeths();
    }

    private MethHeaders check(String className,Map checked,Set visited)throws TypecheckerException{
	if(visited.contains(className))
	    throw new TypecheckerException("Inheritance cycle involving "+className);
	//	if("java.lang.Object".equals(className))
	if(className==null)
	    return new MethHeaders();
	MethHeaders mhs=(MethHeaders) checked.get(className);
	if(mhs!=null)
	    return mhs;
	visited.add(className);
	ClassType ct=(ClassType) get(className);
	FieldDecs fds=ct.getFields();
        Iterator it=fds.values().iterator();
	Type t;
	while(it.hasNext()){
	    t=(Type)it.next();
	    new ExistsAssum(t).entailedBy(this);
	}
	ConsSigs css=ct.getCons();
        it=css.iterator();
	Iterator it2;
	Types ts;
	while(it.hasNext()){
	    ts=(Types)it.next();
	    it2=ts.iterator();
	    while(it2.hasNext())
		new ExistsAssum((Type)it2.next()).entailedBy(this);
	}
	mhs=ct.getMeths();
	MethHeaders mhs2=(MethHeaders) check(ct.getSuperclass(),checked,visited).clone();
        it=mhs.keySet().iterator();
	MethSig ms;
	while(it.hasNext()){
	    ms=(MethSig)it.next();
	    t=(Type)mhs.get(ms);
	    new ExistsAssum(t).entailedBy(this);
	    mhs2.update(ms,t);
	    it2=ms.iterator();
	    while(it2.hasNext())
		new ExistsAssum((Type)it2.next()).entailedBy(this);
	}
	checked.put(className,mhs2);
	return mhs2;
    }

    public void wellFormed()throws TypecheckerException{
	Map checked=new HashMap();
	Iterator it=keySet().iterator();
	String className;
	while(it.hasNext()){
	    className=(String)it.next();
	    check(className,checked,new HashSet());
	}
    }

}

