package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.MethAssum;
import FJsc.typechecker.typeassum.LocEnv;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class InvokeExp extends Exp{

    protected Exp target;
    protected String methName;
    protected Exps args;

    public InvokeExp(Exp target,String methName,Exps args){
	this.target=target;
	this.methName=methName;
	this.args=args;
    } 

    public Type typecheck(Env ce,Env ve,LocEnv le)throws TypecheckerException,IOException{
	ObjectType rt;
	try{
	    rt=(ObjectType) target.typecheck(ce,ve,le);
	}
	catch(ClassCastException e){
	    throw new TypecheckerException("Expecting a reference type");
	}
	Types ts=args.typecheck(ce,ve,le);
	MethAssum ma=new MethAssum(ce,rt,methName,ts);
	le.add(ma);
	return ma.getType();
    }

}
