package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.*;

public class SourceClassDec implements ClassDec{

    protected String name,parent;
    protected FieldDecs fieldDecs;
    protected ConsDecs consDecs;
    protected MethDecs methDecs;


    public SourceClassDec(String name,String parent,FieldDecs fieldDecs,ConsDecs consDecs,MethDecs methDecs){
	this.name=name;
	this.parent=parent;
	this.fieldDecs=fieldDecs;
	this.consDecs=consDecs;
	this.methDecs=methDecs;
    }

    public String getName(){
	return name;
    }

    public String getParent(){
	return parent;
    }

    public FieldDecs getFields(){
	return fieldDecs;
    }

    public ConsDecs getCons(){
	return consDecs;
    }

    public MethDecs getMeths(){
	return methDecs;
    }

    public ClassType getClassType(){
	return new ClassType(parent,fieldDecs,consDecs.getSigs(),methDecs.getHeaders());
    }

    public void typecheck(Env ce,LocEnv le)throws TypecheckerException,IOException{
	consDecs.typecheck(ce,name,le);
	methDecs.typecheck(ce,name,le);
    }

}
