package FJsc.typechecker.typeassum;

import java.io.*;
import java.util.*;
import FJsc.typechecker.*;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;


public class ConsAssum extends TypeAssum{

    protected String className;
    protected Types args,formals;

    public ConsAssum(String className,Types args,Types formals){
    	this.className=className;
    	this.args=args;
	this.formals=formals;
    }

    public ConsAssum(Env ce,String className,Types args)throws TypecheckerException{
	this.className=className;
	this.args=args;
	this.formals=resolve(ce); 
    }

    public boolean alwaysHolds(){
	return className.equals("java.lang.Object") && args.isEmpty() && formals.isEmpty();
    }

    private Types resolve(Env ce)throws TypecheckerException{
	ConsSigs css;
	Types ts;
	css=ce.getCons(className);
	try{
	    ts=mostSpecific(ce,applicable(ce,css));
	    return ts;
	}
	catch(NoApplicableException e){	    
	    throw new TypecheckerException("No applicable constructor found for "+className+"."+args);
	}
	catch(NoMostSpecificException e){		
	    throw new TypecheckerException("Ambiguous constructor invocation "+className+"."+args);
	}
    }

    private List applicable(Env ce,ConsSigs css)throws NoApplicableException{
	List l=new ArrayList();
	Types ts;;
	Iterator it=css.iterator();
	while(it.hasNext()){ 
	    ts=(Types)it.next();
	    if(subtypeOf(ce,args,ts))
		l.add(ts);
	}
	if(l.isEmpty())
	    throw new NoApplicableException();
	return l;
    } 

    public String getClassName(){
	return className;
    }

    public Types getArgs(){
	return args;
    }

    public Types getFormals(){
	return formals;
    }

    public void entailedBy(Env ce)throws TypecheckerException{
	ConsAssum ca=new ConsAssum(ce,className,args);
	if(!formals.equals(ca.formals))
	    throw new TypecheckerException("Cannot resolve constructor invocation "+className+"."+args);
    }

    public String toString(){
	return "cons("+className+","+args+") = "+formals;
    }

    public boolean equals(Object o){
	try{
	    return equals((ConsAssum) o);
	}
	catch(ClassCastException e){
	    return false;
	}
    }

    public boolean equals(ConsAssum ca){
	return className.equals(ca.className) && args.equals(ca.args) && formals.equals(ca.formals);
    }

    public int hashCode(){
	return className.hashCode()+args.hashCode()+formals.hashCode();
    }

}
