package FJsc.typechecker.typeassum;

import FJsc.typechecker.*;
import java.io.*;
import org.apache.bcel.generic.Type;

public class ExistsAssum extends TypeAssum{

    protected Type t;

    public ExistsAssum(Type t){
    	this.t=t;
    }

    public ExistsAssum(Env ce,Type t)throws UndefClassException{
	this(t);
	entailedBy(ce);
    }

    public boolean alwaysHolds(){
	return Type.INT.equals(t) || Type.OBJECT.equals(t);
    }

    public void entailedBy(Env ce)throws UndefClassException{
	if(!(alwaysHolds() || ce.containsKey(t.toString())))
	    throw new UndefClassException(t.toString());
    }

    public String toString(){
	return "E."+t;
    }

    public boolean equals(Object o){
	try{
	    return equals((ExistsAssum) o);
	}
	catch(ClassCastException e){
	    return false;
	}
    }

    public boolean equals(ExistsAssum ea){
	return t.equals(ea.t);
    }

    public int hashCode(){
	return t.hashCode();
    }
}
