package FJsc.typechecker.typeassum;

import java.io.*;
import java.util.*;
import FJsc.typechecker.*;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class FieldAssum extends TypeAssum{

    protected ObjectType target;
    protected String fieldName;
    protected Type type;

    public FieldAssum(ObjectType target,String fieldName,Type type){
    	this.target=target;
    	this.fieldName=fieldName;
	this.type=type;
    }

    public FieldAssum(Env ce,ObjectType target,String fieldName)throws TypecheckerException{
	this.target=target;
	this.fieldName=fieldName;
	this.type=resolve(ce);
    }

    private Type resolve(Env ce)throws TypecheckerException{
	String className=target.toString();
	Type t;
	while(className!=null){
	    t=(Type) ce.getFields(className).get(fieldName);
	    if(t!=null)
		return t;
	    className=ce.getSuperclass(className);
	}
	throw new TypecheckerException("No field "+fieldName+" found in "+target);
    }

    public ObjectType getTarget(){
	return target;
    }

    public String getName(){
	return fieldName;
    }

    public Type getType(){
	return type;
    }

    public void entailedBy(Env ce)throws TypecheckerException{
	FieldAssum fa=new FieldAssum(ce,target,fieldName);
	if(!type.equals(fa.type))
	    throw new TypecheckerException("No field "+fieldName+" found in "+target);
    }

    public String toString(){
	return "field("+target+","+fieldName+") = "+type;
    }

    public boolean equals(Object o){
	try{
	    return equals((FieldAssum) o);
	}
	catch(ClassCastException e){
	    return false;
	}
    }

    public boolean equals(FieldAssum fa){
	return target.equals(fa.target) && fieldName.equals(fa.fieldName) && type.equals(fa.type);
    }

    public int hashCode(){
	return target.hashCode()+fieldName.hashCode()+type.hashCode();
    }

}
