package FJsc.typechecker.typeassum;

import java.io.*;
import java.util.*;
import FJsc.typechecker.*;
import org.apache.bcel.generic.Type;

public class SubtypeAssum extends TypeAssum{

    protected Type t1,t2; // t1 < t2

    public SubtypeAssum(Type t1,Type t2){
    	this.t1=t1;
    	this.t2=t2;
    }

    public SubtypeAssum(Env ce,Type t1,Type t2)throws TypecheckerException{
	this(t1,t2);
	entailedBy(ce);
    }

    public boolean alwaysHolds(){
	return (t1.equals(t2) || !Type.INT.equals(t1) && Type.OBJECT.equals(t2));
    }

    public void entailedBy(Env ce)throws TypecheckerException{
	final String msg=t1+" is not a subtype of "+t2;
	if(alwaysHolds())
	    return;
	if(Type.INT.equals(t1) || Type.INT.equals(t2))
	    throw new TypecheckerException(msg);
	String n1=t1.toString();
	String n2=t2.toString();
	while(n1!=null){
	    if(n1.equals(n2))
		return;
	    n1=ce.getSuperclass(n1);
	}
	throw new TypecheckerException(msg);
    }

    public String toString(){
	return t1+" <= "+t2;
    }

    public boolean equals(Object o){
	try{
	    return equals((SubtypeAssum) o);
	}
	catch(ClassCastException e){
	    return false;
	}
    }

    public boolean equals(SubtypeAssum sa){
	return t1.equals(sa.t1) && t2.equals(sa.t2);
    }

    public int hashCode(){
	return t1.hashCode()+t2.hashCode();
    }
}
